Edje Object File

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files
- Examples

Functions
Edje Object File
Edje » Edje Object

Functions to deals with EDJ files. More...

## Functions
Eina_List * | edje_mmap_collection_list (Eina_File *f)
| Get a list of groups in an edje mapped file. More...
void | edje_mmap_collection_list_free (Eina_List *lst)
| Free file collection list. More...
Eina_Bool | edje_mmap_group_exists (Eina_File *f, const char *glob)
| Determine whether a group matching glob exists in an edje mapped file. More...
Eina_Iterator * | edje_file_iterator_new (void)
| Iterate over all the opened Edje file. More...
Eina_List * | edje_file_collection_list (const char *file)
| Get a list of groups in an edje file. More...
void | edje_file_collection_list_free (Eina_List *lst)
| Free file collection list. More...
Eina_Bool | edje_file_group_exists (const char *file, const char *glob)
| Determine whether a group matching glob exists in an edje file. More...
const char * | edje_load_error_str (Edje_Load_Error error)
| Converts the given Edje file load error code into a string describing it in English. More...

## Detailed Description

Functions to deals with EDJ files.

Layouts in Edje are usually called themes and they are created using the EDC language. The EDC language is declarative and must be compiled before being used. The output of this compilation is an EDJ file, this file can be loaded by Edje, and the result is a edje object.

This groups of functions interact with these EDJ files, either by loading them or retrieving information of the EDC file about objects.

## Function Documentation

Eina_List* edje_mmap_collection_list | ( | Eina_File * | f | ) |

Get a list of groups in an edje mapped file.

Parameters

  f | The mapped file

Returns
  The Eina_List of group names (char *)

Note: the list must be freed using edje_mmap_collection_list_free() when you are done with it.

References eina_hash_iterator_key_new(), EINA_ITERATOR_FOREACH, eina_iterator_free(), eina_list_append(), and eina_stringshare_add().

Referenced by edje_file_collection_list().

void edje_mmap_collection_list_free | ( | Eina_List * | lst | ) |

Free file collection list.

Parameters

  lst | The Eina_List of groups

Frees the list returned by edje_mmap_collection_list().

References edje_file_collection_list_free().

Eina_Bool edje_mmap_group_exists | ( | Eina_File * | f,
|  | const char * | glob
| ) |  |

Determine whether a group matching glob exists in an edje mapped file.

Parameters

  f | The mapped file
  glob | A glob to match on

Returns
  1 if a match is found, 0 otherwise

References DBG, EINA_FALSE, eina_file_filename_get(), eina_hash_find(), eina_hash_iterator_data_new(), EINA_ITERATOR_FOREACH, eina_iterator_free(), eina_list_append(), eina_list_free(), and EINA_TRUE.

Referenced by edje_file_group_exists().

Eina_Iterator* edje_file_iterator_new | ( | void |  | ) |

Iterate over all the opened Edje file.

Returns
  an iterator of Eina_File currently opened Edje file.

Since
  1.14

References eina_hash_iterator_data_new(), and EINA_MAGIC_SET.

Eina_List* edje_file_collection_list | ( | const char * | file | ) |

Get a list of groups in an edje file.

Parameters

  file | The path to the edje file

Returns
  The Eina_List of group names (char *)

See also
  edje_mmap_collection_list()

Note: the list must be freed using edje_file_collection_list_free() when you are done with it.

See also
  edje_mmap_group_exists()

References edje_mmap_collection_list(), EINA_FALSE, eina_file_close(), and eina_file_open().

void edje_file_collection_list_free | ( | Eina_List * | lst | ) |

Free file collection list.

Parameters

  lst | The Eina_List of groups

Frees the list returned by edje_file_collection_list().

References eina_list_data_get(), eina_list_remove(), and eina_stringshare_del().

Referenced by edje_mmap_collection_list_free().

Eina_Bool edje_file_group_exists | ( | const char * | file,
|  | const char * | glob
| ) |  |

Determine whether a group matching glob exists in an edje file.

Parameters

  file | The file path
  glob | A glob to match on

Returns
  1 if a match is found, 0 otherwise

References edje_mmap_group_exists(), EINA_FALSE, eina_file_close(), and eina_file_open().

const char* edje_load_error_str | ( | Edje_Load_Error | error | ) |

Converts the given Edje file load error code into a string describing it in English.

Parameters

  error | the error code, a value in Edje_Load_Error.

Returns
  Always returns a valid string. If the given `error` is not supported, `"Unknown error"` is returned.

edje_object_file_set() is a function which sets an error value, afterwards, which can be fetched with edje_object_load_error_get(). The function in question is meant to be used in conjunction with the latter, for pretty-printing any possible error cause.

Examples:
  edje-basic.c, edje-signals-messages.c, and evas-aspect-hints.c.

References EDJE_LOAD_ERROR_CORRUPT_FILE, EDJE_LOAD_ERROR_DOES_NOT_EXIST, EDJE_LOAD_ERROR_GENERIC, EDJE_LOAD_ERROR_INCOMPATIBLE_FILE, EDJE_LOAD_ERROR_PERMISSION_DENIED, EDJE_LOAD_ERROR_RECURSIVE_REFERENCE, EDJE_LOAD_ERROR_RESOURCE_ALLOCATION_FAILED, EDJE_LOAD_ERROR_UNKNOWN_COLLECTION, and EDJE_LOAD_ERROR_UNKNOWN_FORMAT.